        include "tios.h"
        xdef _library
        xdef hufflib@0000

hufflib@0000:   ;extract
 movem.l d0-d7/a0-a6,-(a7)
 sf      d5
 bsr Extract
 movem.l (a7)+,d0-d7/a0-a6
 rts

extract_string:          ;L
 movem.l d0-d7/a0-a6,-(a7)
 st      d5
 bsr Extract
 movem.l (a7)+,d0-d7/a0-a6
 rts

write_string:            ;L
 movem.l d0-d7/a0-a6,-(a7)
 move.w  #4,-(a7)
WriteString:
 subq    #4,a7
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.l  a0,-(a7)
 move.l  #80,-(a7)
 jsr tios::HeapAlloc
 addq    #4,a7
 move.l  (a7)+,a0
 tst.w   d0
 beq RestoreRegs
 move.w  d0,tmpstrH
 tios::DEREF d0,a1
 move.l  a1,4(a7)
 st      d5
 bsr Extract
 jsr tios::DrawStrXY
 move.w  tmpstrH(PC),-(a7)
 jsr tios::HeapFree
 addq    #2,a7
RestoreRegs:
 lea     10(a7),a7
 movem.l (a7)+,d0-d7/a0-a6
 rts

write_string_inv:          ;L
 movem.l d0-d7/a0-a6,-(a7)
 clr.w   -(a7)
 bra WriteString

check_mem:                   ;L
 movem.l d1-d7/a0-a6,-(a7)
 move.l  #1140,-(a7)
 jsr tios::HeapAlloc
 addq    #4,a7
 tst.w   d0
 beq OutOfMem
 move.w  d0,-(a7)
 jsr tios::HeapFree
 addq    #2,a7
 moveq   #1,d0
OutOfMem:
 movem.l (a7)+,d1-d7/a0-a6
 rts

Extract:
 movem.l a0-a1,-(a7)
 move.l  #1024,-(a7)
 jsr tios::HeapAlloc
 addq    #4,a7
 movem.l (a7)+,a0-a1
 tst.w   d0
 beq Done
 move.w  d0,tableH
 tios::DEREF d0,a6
 move.l  a0,a2
 move.w  (a2)+,d2
 cmp.w   #1,d2
 bne     MultiFiles
 clr.w   d3
MultiFiles:
 move.w  (a2)+,d0
 move.l  a2,a3
 mulu    #6,d2
 add.w   d2,a3
 mulu    #6,d3
 add.w   d3,a2
 move.w  d0,d6
 subq    #1,d6
 move.l  a3,a4
 add.w   d0,a4
 clr.l   d0
 clr.l   d1
UncrunchTree:
 btst.b  d1,(a4)
 beq NoBranch
 move.w  d0,-(a7)
 addq    #2,d0
NextTreeBit:
 addq    #1,d1
 bclr    #3,d1
 beq UncrunchTree
 addq    #1,a4
 bra UncrunchTree
NoBranch:
 clr.b   0(a6,d0)
 move.b  (a3)+,1(a6,d0)
 addq    #2,d0
 tst.w   d6
 beq TreeBuilt
 move.w  (a7)+,d2
 move.w  d0,0(a6,d2)
 bset.b  #7,0(a6,d2)
 dbra    d6,NextTreeBit
TreeBuilt:
 move.w  (a2)+,d0
 add.w   d0,a0
 move.w  (a2)+,d3
 move.w  (a2),d7
 subq    #1,d7
UncrunchData:
 clr.l   d1
CheckTree:
 move.w  0(a6,d1),d2
 bclr    #15,d2
 beq EndOfBranch
 btst.b  d3,(a0)
 bne RightBranch
 addq    #2,d1
 bra NextDataBit
RightBranch:
 move.w  d2,d1
NextDataBit:
 addq    #1,d3
 bclr    #3,d3
 beq CheckTree
 addq    #1,a0
 bra CheckTree
EndOfBranch:
 tst.b   d5
 bne ExtractString
 move.b  d2,(a1)+
Repeat:
 dbra    d7,UncrunchData
 bra Done
ExtractString:
 tst.w   d4
 beq WriteData
 tst.b   d2
 bne Repeat
 subq    #1,d4
 bra Repeat
WriteData:
 move.b  d2,(a1)+
 tst.b   d2
 bne Repeat
Done:
 move.w  tableH(PC),-(a7)
 jsr tios::HeapFree
 addq    #2,a7
 move.w  (a2),d0
 rts

tableH     dc.w 0
tmpstrH    dc.w 0

_library   dc.b "hufflib",0

        end
